import Flutter
import UIKit

public class SwiftPhoneCallerPlugin: NSObject, FlutterPlugin {
  public static func register(with registrar: FlutterPluginRegistrar) {
    let channel = FlutterMethodChannel(name: "phone_caller", binaryMessenger: registrar.messenger())
    let instance = SwiftPhoneCallerPlugin()
    registrar.addMethodCallDelegate(instance, channel: channel)
  }

  public func handle(_ call: FlutterMethodCall, result: @escaping FlutterResult) {
      if (call.method == "callNumber") {
        let arg = call.arguments as? Dictionary<String, Any>
        let number = arg?["number"] as? String
        result(callNumber(number))
     }
  }
    
    private func callNumber(_ number:String?) -> Bool {
        let encodedNumber = number?.addingPercentEncoding(withAllowedCharacters: .urlQueryAllowed)
        var completedNumber = encodedNumber
        if !(encodedNumber?.hasPrefix("tel:") ?? true) {
            completedNumber = "tel://\(encodedNumber ?? "")"
        }
        if(completedNumber != nil){
            print(completedNumber)
            if let url = URL(string: completedNumber!) {
                if !UIApplication.shared.canOpenURL(url) {
                    print("Can not open")
                    return false
                } else {
                    print("Try open")
                    UIApplication.shared.open(url, options: [:], completionHandler: nil)
                    return true
                }
            } else{
                print("Wrong url")
                return false
            }
        } else {
            print("null number")
            return false
        }
    }
}
